/*
 *  Copyright (C) 2013-2014 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: CddDisplayState.c 122 2015-07-17 01:31:28Z ertl-honda $
 */
#include "Rte_CddDisplayState.h"
#include "ModelCarControl.h"
#include "t_syslog.h"

/* ɽ */
static IDT_Angle	cur_angle = 0;
static IDT_Speed	cur_speed = 0;
static IDT_PWM		cur_pwm_angle = 0;
static IDT_PWM		cur_pwm_speed = 0;

/* ʬ̵ͭ */
static boolean		changed_angle = FALSE;
static boolean		changed_speed = FALSE;
static boolean		changed_pwm_angle = FALSE;
static boolean		changed_pwm_speed = FALSE;

/* ɽ */
static IDT_Switch	display_angle = FALSE;
static IDT_Switch	display_speed = FALSE;
static IDT_PWM		display_pwm_angle = FALSE;
static IDT_PWM		display_pwm_speed = FALSE;

/* 󹹿 */
void
update_info(void)
{
	Std_ReturnType	ercd;
	IDT_Angle		angle;
	IDT_Speed		speed;
	IDT_PWM			pwm_angle;
	IDT_PWM			pwm_speed;

	/* ɽ󹹿 */
	ercd = Rte_Read_VehicleInfoIn_angle(&angle);
	ercd += Rte_Read_VehicleInfoIn_speed(&speed);
	ercd += Rte_Read_VehicleInfoIn_pwm_angle(&pwm_angle);
	ercd += Rte_Read_VehicleInfoIn_pwm_speed(&pwm_speed);

	if (ercd != RTE_E_OK) {
		syslog(LOG_INFO, "## Error: Rte_Read_VehicleInfoIn()");
		return;
	}

	/* ͤȤκʬǧʤ򹹿 */
	if (cur_angle != angle) {
		cur_angle = angle;
		changed_angle = TRUE;
	}
	if (cur_speed != speed) {
		cur_speed = speed;
		changed_speed = TRUE;
	}
	if (cur_pwm_angle != pwm_angle) {
		cur_pwm_angle = pwm_angle;
		changed_pwm_angle = TRUE;
	}
	if (cur_pwm_speed != pwm_speed) {
		cur_pwm_speed = pwm_speed;
		changed_pwm_speed = TRUE;
	}
}

/* ɽ */
void
display_info(IDT_Switch forced)
{
	uint8 str[64];
	Std_ReturnType	ercd;

	/* ɽֹ */
	ercd = Rte_Read_DisplayModeIn_angle(&display_angle);
	ercd += Rte_Read_DisplayModeIn_speed(&display_speed);
	ercd += Rte_Read_DisplayModeIn_pwm_angle(&display_pwm_angle);
	ercd += Rte_Read_DisplayModeIn_pwm_speed(&display_pwm_speed);
	if (ercd != RTE_E_OK) {
		syslog(LOG_INFO, "## Error: Rte_Read_DisplayModeIn()");
		return;
	}

	/* ǥߥ */
	tSendSBDBTUart("===============================\r\n");

	/* ɳ */
	if ((display_angle == TRUE) &&
		((forced == TRUE) || (changed_angle == TRUE))) {
		sprintf(str, "SteeringAngle: %d\r\n", cur_angle);
		tSendSBDBTUart(str);
	}

	/* ư® */
	if ((display_speed == TRUE) &&
		((forced == TRUE) || (changed_speed == TRUE))) {
		sprintf(str, "DrivingSpeed: %d\r\n", cur_speed);
		tSendSBDBTUart(str);
	}

	/* ɳPWM */
	if ((display_pwm_angle == TRUE) &&
		((forced == TRUE) || (changed_pwm_angle == TRUE))) {
		sprintf(str, "ServoPwmAngle: %d\r\n", cur_pwm_angle);
		tSendSBDBTUart(str);
	}

	/* ư®PWM */
	if ((display_pwm_speed == TRUE) &&
		((forced == TRUE) || (changed_pwm_speed == TRUE))) {
		sprintf(str, "EscPwmSpeed: %d\r\n", cur_pwm_speed);
		tSendSBDBTUart(str);
	}
}

void
DisplayState(void)
{
	Std_ReturnType		ercd;
	IDT_Cycle			cycle = 0U;
	IDT_Switch			differ;
	static uint8		cnt = 0U;
	static uint8		max = 0U;
	static IDT_Cycle	pre_cycle = 0U;
	static boolean		one_shot = FALSE;

	/* ɽɤ߹ */
	ercd = Rte_Read_DisplayModeIn_cycle(&cycle);
	if (ercd != RTE_E_OK) {
		syslog(LOG_INFO, "## Error: Rte_Read_DisplayModeIn_cycle()");
	}

	/* ɽʤ */
	if (cycle == 0U) {
		/* 󥷥åȺѤߥե饰OFF */
		one_shot = FALSE;
	}
	/* 󥷥å */
	else if (cycle == 1U) {
		/* 򹹿ƶŪ1ɽ */
		if (one_shot == FALSE) {
			update_info();
			display_info(TRUE);
			/* ¾ɽڤؤޤɽʤ */
			one_shot = TRUE;
		}
	}
	else if (((cycle % 100U) == 0U) && (cycle <= 10000U)) {
		/* 󤫤ɽѤäƤ祫󥿡ͤꥻå */
		if (cycle != pre_cycle) {
			cnt = 0U;
			max = cycle / 100U;
		}

		/* ˹碌ƾɽ */
		cnt++;
		if (max < cnt) {
			ercd = Rte_Read_DisplayModeIn_differ(&differ);
			if (ercd != RTE_E_OK) {
				syslog(LOG_INFO, "## Error: Rte_Read_DisplayModeIn_cycle()");
			}
			else {
				update_info();
				if (differ == TRUE) {
					display_info(FALSE);
				}
				else {
					display_info(TRUE);
				}
			}
			cnt = 0U;
		}

		/* ͹ */
		pre_cycle = cycle;

		/* 󥷥åȺѤߥե饰OFF */
		one_shot = FALSE;
	}
	else {
		syslog(LOG_INFO, "## Error: Invalid cycle value: %d", cycle);
	}
}
